using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Design;
using System.ComponentModel.Design;

using System.Reflection;

namespace FormDesigner
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


private void Form1_Load(object sender, EventArgs e)
{
    DesignSurface surface = new DesignSurface();

    toolBoxService = new DemoToolboxService();
    toolBoxService.ToolBox = new ListBox();

    toolBoxService.ToolBox.Items.Add("Point");

    toolBoxService.ToolBox.Items.Add(new ToolboxItem(typeof(Button)));
    toolBoxService.ToolBox.Items.Add(new ToolboxItem(typeof(TextBox)));
    toolBoxService.ToolBox.Items.Add(new ToolboxItem(typeof(Label)));
    toolBoxService.ToolBox.Items.Add(new ToolboxItem(typeof(TabControl)));
    toolBoxService.ToolBox.Items.Add(new ToolboxItem(typeof(StatusBar)));

   // Assembly a1=Assembly.LoadFrom(@"D:\Dotnet\MyControl.dll");
   // toolBoxService.ToolBox.Items.Add(new ToolboxItem(a1.GetType("MyControl.ComboBoxField")));

    toolBoxService.ToolBox.Dock = DockStyle.Fill;
    this.panel1.Controls.Add(toolBoxService.ToolBox);


    IServiceContainer container = surface.GetService(typeof(IServiceContainer)) as IServiceContainer;

    menuCommandService = new MenuCommandService(surface);

    if (container != null)
    {
        container.AddService(typeof(IToolboxService), toolBoxService);
        container.AddService(typeof(IMenuCommandService), menuCommandService);
    }

    surface.BeginLoad(typeof(Form));
    Control view = (Control)surface.View;
    view.Dock = DockStyle.Fill;
    this.splitContainer1.Panel1.Controls.Add(view);
    this.propertyGrid1.SelectedObject = surface.ComponentContainer.Components[0];


    selectionService = surface.GetService(typeof(ISelectionService)) as ISelectionService;
    selectionService.SelectionChanged += new EventHandler(selectionService_SelectionChanged);
}

        void selectionService_SelectionChanged(object sender, EventArgs e)
        {
            object[] selection;
            if (selectionService.SelectionCount == 0)
                propertyGrid1.SelectedObject = null;
            else
            {
                selection = new object[selectionService.SelectionCount];
                selectionService.GetSelectedComponents().CopyTo(selection, 0);
                propertyGrid1.SelectedObjects = selection;
            }
 
        }

        private DemoToolboxService toolBoxService;
        private ISelectionService selectionService;
        private MenuCommandService menuCommandService;


        private void selectAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            menuCommandService.GlobalInvoke(StandardCommands.SelectAll);
        }

        private void deleteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            menuCommandService.GlobalInvoke(StandardCommands.Delete);
        }

    }
}